<html>
  <head>
    <TITLE>Memory debugging and profiling tools</TITLE>
    <LINK REL=STYLESHEET  TYPE="text/css" HREF="../bluestripe.css" TITLE="Bluestripe">
  </head>

  <body>
    <H1>Memory debugging and profiling tools</H1>

    <dl>
      <dt><a href="http://www.hpl.hp.com/personal/Hans_Boehm/gc/">Boehm GC</a></dt>
      <dd>
	<p>
	  The Boehm Garbage Collector is a conservative garbage
	  collector that works by scanning memory for pointers to
	  blocks of memory. While the Boehm GC is mostly meant for
	  memory management, it also has a mode for leak detection in
	  programs that manually free memory.
	</p>
      </dd>

      <dt>Debauch</dt>
      <dd>
	<p>
	  A comprehensive tool for tracking memory usage and finding
	  memory leaks; it works on unmodified binaries by overriding
	  the memory allocation functions with a LD_PRELOAD; it finds
	  leaks by conservatively scanning memory. It is based on a a
	  tool (memleak) which Keith Packard wrote while working on X.
	  (No current link known.)
	</p>
      </dd>

      <dt><a href="http://dmalloc.com/">DMalloc</a></dt>
      <dd>
	<p>
	  DMalloc is a very portable replacement for the C libraries
	  memory allocation routines with a wide range of facilities
	  for debugging and gathering statistics.
	</p>
      <dd>

      <dt><a href="ftp://ftp.perens.com/pub/ElectricFence/">ElectricFence</a></dt>
      <dd>
	<p>
	  ElectricFence catches buffer overruns by guarding each block
	  of memory with write-protected pages.
	</p>
      </dd>

      <dt>GNU C Library</dt>
      <dd>
	<p>
	  The GNU C Library includes memory checking code that can be
	  turned on by setting the environment variable
	  <tt>MALLOC_CHECK_</tt>. See the info page documentation for
	  more information on this feature. While fairly simple, it
	  is effective at finding double-frees of memory, and has
	  little overhead.
	</p>
      </dd>

      <dt><a href="http://people.redhat.com/otaylor/memprof/">MemProf</a></dt>
      <dd>
	<p>
	  MemProf (by the author of this page) is a memory leak
	  detector and profiler that works in a somewhat similar
	  fashion to Debauch. It's notable feature is a nice graphical
	  front end. MemProf works only on Linux.
	</p>
      <dd>

      <dt><a href="http://developer.kde.org/~sewardj/">Valgrind</a></dt>
      <dd>
	<p>
	  Valgrind is a powerful tool that rewrites the object
          code of the application as it is executed to allow the
          detection of many sorts of memory errors, including
          such things as out-of-bounds writes and use of unitialized
          memory. One of the side-capabilities of Valgrind is the
          ability to detect leaked memory blocks by conservatively
          scanning memory.
	</p>
      <dd>
</dl>

    <hr>

    <H4>In case of questions contact Holger Freyther<A HREF="mailto:zecke+memprof@secretlabs.de">
    &lt;zecke+memprof@secretlabs.de&gt;</A></H4>
    <P>Return to my <A HREF="../index.html">home page</A> </body>

</html>
